package com.mq.nfctool;

import android.app.PendingIntent;
import android.content.Intent;
import android.nfc.FormatException;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.MifareClassic;
import android.nfc.tech.Ndef;
import android.os.Parcelable;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Base64;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NFCActivity extends AppCompatActivity {
    private static final String TAG = "NFCActivity";

    private String mTagText;
    private EditText mTvContent;
    private TextView mTvMsg;
    private NfcAdapter mNfcAdapter;
    private PendingIntent mPendingIntent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nfc);
        mTvContent = findViewById(R.id.tv_content);
        mTvMsg = findViewById(R.id.tv_msg);
    }

    @Override
    protected void onStart() {
        super.onStart();
        mNfcAdapter = NfcAdapter.getDefaultAdapter(this);
        //一旦截获NFC消息，就会通过PendingIntent调用窗口
        mPendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, getClass()), 0);
    }

    @Override
    protected void onResume() {
        super.onResume();
        //设置处理优于所有其他NFC的处理
        if (mNfcAdapter != null)
            mNfcAdapter.enableForegroundDispatch(this, mPendingIntent, null, null);
    }

//    @Override
//    protected void onNewIntent(Intent intent) {
//        if (NfcAdapter.ACTION_TAG_DISCOVERED.equals(intent.getAction())) {
//            mTvMsg.setText("读卡中");
//
//            StringBuffer sb = new StringBuffer();
//            Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
//            sb.append("可用技术: \n");
//            for (String tech : tag.getTechList()) {
//                sb.append(tech);
//                sb.append("\n");
//            }
//            sb.append("\n------------------------\n");
//            MifareClassic mc = MifareClassic.get(tag);
//            try {
//                mc.connect();
//                int type = mc.getType();//获取TAG的类型
//                int sectorCount = mc.getSectorCount();//获取扇区数
//                sb.append("\n卡片连接成功")
//                        .append("\n卡片类型:");
//                switch (type) {
//                    case MifareClassic.TYPE_CLASSIC:
//                        sb.append("TYPE_CLASSIC");
//                        break;
//                    case MifareClassic.TYPE_PLUS:
//                        sb.append("TYPE_PLUS");
//                        break;
//                    case MifareClassic.TYPE_PRO:
//                        sb.append("TYPE_PRO");
//                        break;
//                    case MifareClassic.TYPE_UNKNOWN:
//                        sb.append("TYPE_UNKNOWN");
//                        break;
//                }
//                sb.append("\n共")
//                        .append(sectorCount)
//                        .append("个扇区\n共")
//                        .append(mc.getBlockCount())
//                        .append("个块\n存储空间: ")
//                        .append(mc.getSize())
//                        .append("B\n");
//                sb.append("\n------------------------\n");
//
//                StringBuffer sbResult = new StringBuffer();
//
//                for (int i = 0; i < sectorCount; i++) {
//                    //验证扇区
//                    boolean auth = mc.authenticateSectorWithKeyA(i, MifareClassic.KEY_DEFAULT);
//                    if (auth) {
//                        //获取扇区中的块数
//                        int blockCount = mc.getBlockCountInSector(i);
//                        sb.append("\n")
//                                .append(i)
//                                .append("扇区验证通过,共")
//                                .append(blockCount)
//                                .append("个块\n");
//
//                        int blockIndex = mc.sectorToBlock(i);
//                        for (int j = 0; j < blockCount; j++) {
//                            byte[] data = mc.readBlock(blockIndex);//读取块中的字节
//
//                            String strRead = new String(data, "gb2312");
//                            String result = "";
//                            if (i != 0 || j != 0)
//                                if (j < blockCount - 1)
//                                    sbResult.append(strRead);
//
//                            //数据解析
//                            try {
//                                if (strRead.contains("*")) {
//                                    //*代表结尾, 截取结尾前的数据,转换成字符串
//                                    String substring = strRead.substring(0, strRead.indexOf("*"));
//                                    result = new String(Base64.decode(substring.getBytes(), Base64.DEFAULT), "gb2312");
//                                } else if ("0000000000000000".equals(strRead)) {
//                                    //0000000000000000 无数据,直接赋值
//                                    result = strRead;
//                                } else {
//                                    result = new String(Base64.decode(strRead.getBytes(), Base64.DEFAULT), "gb2312");
//                                }
//                            } catch (Exception e) {
//                                //解析失败直接赋值
//                                result = strRead;
//                            }
//                            sb.append(i)
//                                    .append("扇区, ")
//                                    .append(j)
//                                    .append("块,数据: ")
//                                    .append(result)
//                                    .append("\n");
//                            blockIndex++;
//                        }
//
//                    } else {
//                        sb.append(i + "区验证失败");
//                    }
//                }
//                String debugStr = sbResult.toString();
//                String debugStrResult = null;
//                if (debugStr.contains("*")) {
//                    debugStrResult = debugStr.substring(0, debugStr.indexOf("*"));
//                } else {
//                    debugStrResult = debugStr;
//                }
//                byte[] debugBytes = Base64.decode(debugStrResult.getBytes(), Base64.DEFAULT);
//                String gb2312 = new String(debugBytes, "gb2312");
//                StringBuffer buffer = new StringBuffer();
//                String[] split = gb2312.split("\\|");
//                buffer.append("字段数:")
//                        .append(split.length)
//                        .append("\n");
//                for (int i = 0; i < split.length; i++) {
//                    buffer.append(split[i])
//                            .append("\n");
//                }
//                sb.append("\n------------------------\n")
//                        .append("所需数据解析:\n")
//                        .append(buffer.toString());
//            } catch (Exception e) {
//                e.printStackTrace();
//                Log.e(TAG, "NFC读取异常: " + e);
//            } finally {
//                try {
//                    mc.close();
//                } catch (Exception e) {
//                    e.printStackTrace();
//                }
//            }
//            mTvContent.setText(sb.toString());
//        }
//        mTvMsg.setText("读卡结束");
//    }


    @Override
    protected void onNewIntent(Intent intent) {
        if (NfcAdapter.ACTION_TAG_DISCOVERED.equals(intent.getAction())) {

            mTvMsg.setText("读卡中");

            StringBuffer sb = new StringBuffer();
            Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
            sb.append("可用技术: \n");
            for (String tech : tag.getTechList()) {
                sb.append(tech).append("\n");
            }
            sb.append("\n------------------------\n");
            MifareClassic mc = MifareClassic.get(tag);
            try {
                mc.connect();
                if (!mc.isConnected()) {
                    sb.append("卡片连接失败")
                            .append("\n");
                    mTvContent.setText(sb.toString());
                    mTvMsg.setText("读卡结束");
                    return;
                }
                int type = mc.getType();//获取TAG的类型
                int sectorCount = mc.getSectorCount();//获取扇区数
                sb.append("卡片连接成功")
                        .append("\n")
                        .append("卡片类型:");
                switch (type) {
                    case MifareClassic.TYPE_CLASSIC:
                        sb.append("TYPE_CLASSIC");
                        break;
                    case MifareClassic.TYPE_PLUS:
                        sb.append("TYPE_PLUS");
                        break;
                    case MifareClassic.TYPE_PRO:
                        sb.append("TYPE_PRO");
                        break;
                    case MifareClassic.TYPE_UNKNOWN:
                        sb.append("TYPE_UNKNOWN");
                        break;
                }
                sb.append("\n扇区:")
                        .append(sectorCount)
                        .append("\n块:")
                        .append(mc.getBlockCount())
                        .append("\n存储空间: ")
                        .append(mc.getSize())
                        .append("B");
                sb.append("\n------------------------\n");

                StringBuffer sbResult = new StringBuffer();

                List<byte[]> byteList = new ArrayList<>();

                for (int i = 0; i < sectorCount; i++) {
                    //验证扇区
                    boolean auth = false;
                    if (mc.authenticateSectorWithKeyA(i, MifareClassic.KEY_MIFARE_APPLICATION_DIRECTORY)) {
                        auth = true;
                    } else if (mc.authenticateSectorWithKeyA(i, MifareClassic.KEY_DEFAULT)) {
                        auth = true;
                    } else if (mc.authenticateSectorWithKeyA(i, MifareClassic.KEY_NFC_FORUM)) {
                        auth = true;
                    } else {
                        Log.d("TAG", "Authorization denied ");
                    }
                    if (!auth) {
                        sb.append(i).append("扇区验证失败")
                                .append("\n");
                        mTvContent.setText(sb.toString());
                        mTvMsg.setText("读卡结束");
                        return;
                    }

                    //获取扇区中的块数
                    int blockCount = mc.getBlockCountInSector(i);
                    sb.append("\n")
                            .append(i)
                            .append("扇区验证通过,共")
                            .append(blockCount)
                            .append("个块\n");

                    int blockIndex = mc.sectorToBlock(i);
                    for (int j = 0; j < blockCount; j++) {
                        byte[] data = mc.readBlock(blockIndex);//读取块中的字节

                        String strRead = new String(data, "gb2312");
//                        String result = "";
                        if (i != 0 || j != 0)
                            if (j < blockCount - 1) {
                                sbResult.append(strRead);
                                byteList.add(data);
                            }

//                            //数据解析
//                            try {
//                                if (strRead.contains("*")) {
//                                    //*代表结尾, 截取结尾前的数据,转换成字符串
//                                    String substring = strRead.substring(0, strRead.indexOf("*"));
//                                    result = new String(substring.getBytes(), "gb2312");
//                                } else if ("0000000000000000".equals(strRead)) {
//                                    //0000000000000000 无数据,直接赋值
//                                    result = strRead;
//                                } else {
//                                    result = new String(strRead.getBytes(), "gb2312");
//                                }
//                            } catch (Exception e) {
//                                //解析失败直接赋值
//                                result = strRead;
//                            }
//                        sb.append(i)
//                                .append("扇区, ")
//                                .append(j)
//                                .append("块,数据: ")
//                                .append(strRead)
//                                .append("\n");
                        blockIndex++;
                    }
                }
                mc.close();

                sb.append("读取结果:\n").append(sbResult.toString());
                int count = 0;
                for (byte[] bytes : byteList) {
                    count += bytes.length;
                }
                sb.append("读取字节总数:")
                        .append(count)
                        .append("\n");
                byte[] byteResult = new byte[count];
                int index = 0;
                for (byte[] bytes : byteList) {
                    for (byte b : bytes) {
                        byteResult[index] = b;
                        index++;
                    }
                }
                String result = new String(byteResult, "gb2312");
                sb.append("读取结果:")
                        .append(result)
                        .append("\n");
//                String debugStr = sbResult.toString();
                String debugStrResult = null;
                if (result.contains("*")) {
                    debugStrResult = result.substring(0, result.indexOf("*"));
                } else {
                    debugStrResult = result;
                }
//                byte[] debugBytes = debugStrResult.getBytes();
//                String gb2312 = new String(debugBytes, "gb2312");
                StringBuffer buffer = new StringBuffer();
                String[] split = debugStrResult.split("\\|");
                buffer.append("字段数:")
                        .append(split.length)
                        .append("\n");

                for (int i = 0; i < split.length; i++) {
                    buffer.append(split[i])
                            .append("\n");
                }
                sb.append("\n------------------------\n")
                        .append("所需数据解析:\n")
                        .append(buffer.toString());

            } catch (Exception e) {
                e.printStackTrace();
                Log.e(TAG, "NFC读取异常: " + e);
                sb.append("NFC读取异常:\n");
                sb.append(e.toString());
            }
            mTvContent.setText(sb.toString());
        }
        mTvMsg.setText("读卡结束");

    }

    /**
     * 暂停Activity，界面获取焦点
     */
    @Override
    public void onPause() {
        super.onPause();
        //恢复默认状态
        if (mNfcAdapter != null)
            mNfcAdapter.disableForegroundDispatch(this);
    }

    public void onClick(View view) {
        mTvContent.setText("");
        mTvMsg.setText("请重新放卡");
    }
}
